library ieee;

use ieee.numeric_std.all;
use ieee.std_logic_1164.all;

entity dds_test is
end entity dds_test;

architecture test of dds_test is

component dds is
	port(clk : in std_logic;
		 incr : in unsigned(31 downto 0);
		 res : out unsigned(7 downto 0));
end component;

signal incr : unsigned(31 downto 0);
signal incrvec : std_logic_vector(31 downto 0);
signal res : unsigned(7 downto 0);

constant num_cycles : integer := 30;
signal clock : std_ulogic := '1';
  
begin
	dds1 : dds port map(clk => clock, incr => incr, res => res);

	process
	begin
		--report "start!";
		incrvec <= x"00000001";
		wait for 10 ps;
		incr <= unsigned(incrvec);
		wait for 10 ps;
		for i in 1 to num_cycles loop
			--report "run";
			clock <= not clock;
			wait for 5 ns;
			clock <= not clock;
			wait for 5 ns;
			-- clock period = 10 ns
		end loop;
		wait;  -- simulation stops here
	end process;
end test;